clear
% 
%  
width = 720; height = 576;
centerX = width/2; centerY = height/2;
%  ,  ,    
%  720576 aspect = 30/28 = 1.0714,     
%  768576 blocksizeX = 30  aspect = 1
blocksizeX = 28; blocksizeY = 30;
%  .  !  !
blocksX = 24; blocksY = 18;
%  
linesizeX = 2; linesizeY = 2;
% 
minlevel = 0/255;
maxlevel = 255/255;
razmah = maxlevel - minlevel;
level375 = 0.375*razmah + minlevel;
level750 = 0.75*razmah + minlevel;
%   ( )
% fs = 13.5;
fs = width/720 *13.5;
%    
imout (1:height,1:width,1:3) = minlevel;
%   .  37.5%/75%
tmpX1 = centerX - blocksizeX * blocksX/2;
tmpY1 = centerY - blocksizeY * blocksY/2;
tmpX2 = centerX + blocksizeX * blocksX/2 + linesizeX-1;
tmpY2 = centerY + blocksizeY * blocksY/2 + linesizeY-1;
imout(tmpY1:tmpY2,tmpX1:tmpX2,:) = level375;
for i = tmpX1:blocksizeX:width
    imout(tmpY1:tmpY2,i:(i+linesizeX-1),:) = level750;
end
for i = tmpY1:blocksizeY:height
    imout(i:(i+linesizeY-1),tmpX1:tmpX2,:) = level750;
end
%  
tmpY1 = centerY - blocksizeY + linesizeY;
tmpY2 = centerY + blocksizeY - 1;
tmpX1 = centerX - blocksizeX * 3 + linesizeX;
tmpX2 = centerX - blocksizeX - 1;
imout(tmpY1:tmpY2,tmpX1:tmpX2,:) = level375;
tmpX1 = centerX + blocksizeX + linesizeX;
tmpX2 = centerX + blocksizeX * 3 - 1;
imout(tmpY1:tmpY2,tmpX1:tmpX2,:) = level375;
tmpX1 = centerX - blocksizeX * 2;
tmpX2 = centerX + blocksizeX * 2;
imout(centerY:(centerY+1),tmpX1:(tmpX1+1),:) = level750;
imout(centerY:(centerY+1),tmpX2:(tmpX2+1),:) = level750;
%   .  0%/100%
%   
for i = (centerX - blocksizeX*11 + linesizeX):(blocksizeX*2):(width-blocksizeX)
    imout(1:(centerY - blocksizeY*9 - 1),i:(i+blocksizeX-1),:) = maxlevel;
    imout((centerY + blocksizeY*9 + linesizeY):height,i:(i+blocksizeX-1),:) = maxlevel;
end
%   
tmpY1 = (centerY - blocksizeY*9)/2
imout((tmpY1-linesizeY+1):tmpY1,:,:) = maxlevel;
%   
tmpY2 = centerY + blocksizeY*9 + linesizeY + tmpY1;
imout((tmpY2-linesizeY+1):tmpY2,:,:) = maxlevel;
%  
for i = (centerY - blocksizeY*9 + linesizeY):(blocksizeY*2):(height-blocksizeY)
    imout(i:(i+blocksizeY-1),1:(centerX - blocksizeX*12 - 1),:) = maxlevel;
end
%  
for i = (centerY - blocksizeY*8 + linesizeY):(blocksizeY*2):(height-blocksizeY)
    imout(i:(i+29),(centerX + blocksizeX*12 + linesizeX):width,:) = maxlevel;
end
%   
tmpX1 = (centerX-blocksizeX*12)/2;
imout(:,(tmpX1-1):tmpX1,:) = maxlevel;
tmpX2 = centerX + blocksizeX*12 + linesizeX + tmpX1;
imout(:,(tmpX2-1):tmpX2,:) = maxlevel;
%  
%  
imout(1:(centerY - blocksizeY*9 -1),1:(centerX - blocksizeX*12 + linesizeX -1),:) = maxlevel;
%  
imout((centerY + blocksizeY*9 + linesizeY):height,1:(centerX - blocksizeX*12 + linesizeX -1),:) = maxlevel;
%  
imout(1:(centerY - blocksizeY*9 + linesizeY -1),(centerX + blocksizeX*12 + linesizeX):width,:) = maxlevel;
%  
mask(1:height,1:width) = 0;
%    
Axradius = blocksizeX*8 - linesizeX; Ayradius = blocksizeY*8 - linesizeY;
Axcenter = centerX + 0.5; Aycenter = centerY + 0.5;
for i = floor(Aycenter-Ayradius-10):ceil(Aycenter+Ayradius+10)
    Atmp = Ayradius^2 - (i-Aycenter)^2;
    if Atmp > 0
        Axlength = sqrt(Atmp)*Axradius/Ayradius;
        Astart = ceil(Axcenter-Axlength);
        Astartfr = 1-rem(Axcenter-Axlength,1);
        Astop =  floor(Axcenter+Axlength);
        Astopfr = rem(Axcenter+Axlength,1);
        mask(i,Astart:Astop) = 1;
        mask(i,(Astart-1)) = Astartfr;
        mask(i,(Astop+1)) = Astopfr;
    end
end
%  ""     
tmpY1 = Aycenter-0.5-blocksizeY*7.5;
tmpX1 = Axcenter-0.5-blocksizeX*2;
mask((tmpY1+1):(tmpY1+blocksizeY),tmpX1:(tmpX1+blocksizeX*4)) = 0;
tmpY1 = Aycenter-0.5-blocksizeY*6;
tmpX1 = Axcenter-0.5-blocksizeX*5;
mask((tmpY1+1):(tmpY1+blocksizeY),tmpX1:(tmpX1+blocksizeX*10)) = 0;
tmpY1 = Aycenter-0.5+blocksizeY*6.5;
tmpX1 = Axcenter-0.5-blocksizeX*2;
mask((tmpY1+1):(tmpY1+blocksizeY),tmpX1:(tmpX1+blocksizeX*4)) = 0;
tmpY1 = Aycenter-0.5-blocksizeY;
tmpX1 = Axcenter-0.5-blocksizeX*3 + linesizeX;
mask((tmpY1+1):(tmpY1+2*blocksizeY),tmpX1:(tmpX1+blocksizeX*6-linesizeX-1)) = 0;
%     
Axradius = blocksizeX*2-linesizeX;
Ayradius = blocksizeY*2-linesizeY;
Axcenter = centerX-blocksizeX*9+0.5;
Aycenter = height/2-blocksizeY*7+0.5;
for i = floor(Aycenter-Ayradius-10):ceil(Aycenter+Ayradius+10)
    Atmp = Ayradius^2 - (i-Aycenter)^2;
    if Atmp > 0
        Axlength = sqrt(Atmp)*Axradius/Ayradius;
        Astart = ceil(Axcenter-Axlength);
        Astartfr = 1-rem(Axcenter-Axlength,1);
        Astop =  floor(Axcenter+Axlength);
        Astopfr = rem(Axcenter+Axlength,1);
        mask(i,Astart:Astop) = 1;
        mask(i,(Astart-1)) = Astartfr;
        mask(i,(Astop+1)) = Astopfr;
    end
end
mask((centerY-blocksizeY*8):(centerY-blocksizeY*6),(centerX-blocksizeX*10):(centerX-blocksizeX*8)) = 0;
%     
Axcenter = centerX+blocksizeX*9+0.5;
Aycenter = centerY-blocksizeY*7+0.5;
for i = floor(Aycenter-Ayradius-10):ceil(Aycenter+Ayradius+10)
    Atmp = Ayradius^2 - (i-Aycenter)^2;
    if Atmp > 0
        Axlength = sqrt(Atmp)*Axradius/Ayradius;
        Astart = ceil(Axcenter-Axlength);
        Astartfr = 1-rem(Axcenter-Axlength,1);
        Astop =  floor(Axcenter+Axlength);
        Astopfr = rem(Axcenter+Axlength,1);
        mask(i,Astart:Astop) = 1;
        mask(i,(Astart-1)) = Astartfr;
        mask(i,(Astop+1)) = Astopfr;
    end
end
mask((centerY-blocksizeY*8):(centerY-blocksizeY*6),(centerX+blocksizeX*8):(centerX+blocksizeX*10)) = 0;
%     
Axcenter = centerX-blocksizeX*9+0.5;
Aycenter = centerY+blocksizeY*7+0.5;
for i = floor(Aycenter-Ayradius-10):ceil(Aycenter+Ayradius+10)
    Atmp = Ayradius^2 - (i-Aycenter)^2;
    if Atmp > 0
        Axlength = sqrt(Atmp)*Axradius/Ayradius;
        Astart = ceil(Axcenter-Axlength);
        Astartfr = 1-rem(Axcenter-Axlength,1);
        Astop =  floor(Axcenter+Axlength);
        Astopfr = rem(Axcenter+Axlength,1);
        mask(i,Astart:Astop) = 1;
        mask(i,(Astart-1)) = Astartfr;
        mask(i,(Astop+1)) = Astopfr;
    end
end
mask((centerY+blocksizeY*6):(centerY+blocksizeY*8),(centerX-blocksizeX*10):(centerX-blocksizeX*8)) = 0;
%     
Axcenter = centerX+blocksizeX*9+0.5;
Aycenter = centerY+blocksizeY*7+0.5;
for i = floor(Aycenter-Ayradius-10):ceil(Aycenter+Ayradius+10)
    Atmp = Ayradius^2 - (i-Aycenter)^2;
    if Atmp > 0
        Axlength = sqrt(Atmp)*Axradius/Ayradius;
        Astart = ceil(Axcenter-Axlength);
        Astartfr = 1-rem(Axcenter-Axlength,1);
        Astop =  floor(Axcenter+Axlength);
        Astopfr = rem(Axcenter+Axlength,1);
        mask(i,Astart:Astop) = 1;
        mask(i,(Astart-1)) = Astartfr;
        mask(i,(Astop+1)) = Astopfr;
    end
end
mask((centerY+blocksizeY*6):(centerY+blocksizeY*8),(centerX+blocksizeX*8):(centerX+blocksizeX*10)) = 0;
%   
maskInv = 1 - mask;
% ,   ,    imcycle
imcycle(1:height,1:width,1:3) = level750;
%  ""
Atmp (1:(blocksizeX*16-linesizeX),1:3) = 0;
for i = 1:(blocksizeX*16-linesizeX)
    colRBY = -0.5 + 1*(i-1)/(blocksizeX*16+linesizeX-1);
    colRB = colRBY + 0.5;
    Atmp(i,1) = minlevel + colRB*razmah;
    Atmp(i,3) = minlevel + colRB*razmah;
    Atmp(i,2) = minlevel + (0.5-0.41*colRB)/0.59*razmah;
end
for i = (centerY+blocksizeY+linesizeY):(centerY+2*blocksizeY-1)
    imcycle(i:i,(centerX-blocksizeX*8+linesizeX):(centerX+blocksizeX*8-1),1:3) = Atmp;
end
%   
for i = 0:32
    if (i<10)
        if mod(i,2) == 0
            tmpG = level750; tmpR = level375; tmpB = level375;
        else
            tmpG = level375; tmpR = level750; tmpB = level750;
        end
    end
    if (i>9)&(i<22)
        if mod(i,2) == 0
            tmpG = level375; tmpR = level375; tmpB = level750;
        else
            tmpG = level750; tmpR = level750; tmpB = level375;
        end
    end
    if (i>21)
        if mod(i,2) == 0
            tmpG = level750; tmpR = level375; tmpB = level750;
        else
            tmpG = level375; tmpR = level750; tmpB = level375;
        end
    end
    tmpY1 = centerY-blocksizeY*2+linesizeY;
    tmpY2 = centerY-blocksizeY-1;
    tmpX1 = centerX-blocksizeX*8 + i*blocksizeX/2;
    tmpX2 = centerX-blocksizeX*8 + (i+1)*blocksizeX/2 -1;
    imcycle(tmpY1:tmpY2,tmpX1:tmpX2,1) = tmpR;
    imcycle(tmpY1:tmpY2,tmpX1:tmpX2,2) = tmpG;
    imcycle(tmpY1:tmpY2,tmpX1:tmpX2,3) = tmpB;
end
%  
tmpY1 = centerY; tmpY2 = centerY + blocksizeY - 1;
tmpX1 = centerX - blocksizeX*8 + linesizeX; tmpX2 = centerX - blocksizeX*3 + linesizeX -1;
imcycle(tmpY1:tmpY2,tmpX1:tmpX2,:) = minlevel;
%
tmpX1 = centerX + blocksizeX*3; tmpX2 = centerX + blocksizeX*8 -1;
tmpY1 = centerY - blocksizeY + linesizeY; tmpY2 = centerY + linesizeY - 1;
imcycle(tmpY1:tmpY2,tmpX1:tmpX2,:) = minlevel;
%
tmpX1 = centerX - blocksizeX*7.5;
tmpY1 = centerY - blocksizeY + linesizeY; tmpY2 = centerY + linesizeY - 1;
imcycle(tmpY1:tmpY2,tmpX1:(tmpX1+1),:) = minlevel;
%
tmpY1 = centerY + linesizeY; tmpY2 = centerY + blocksizeY - 1;
imcycle(tmpY1:tmpY2,tmpX1:(tmpX1+1),:) = level750;
%
tmpY1 = centerY; tmpY2 = centerY + linesizeY - 1
tmpX1 = centerX - blocksizeX*6;
imcycle(tmpY1:tmpY2,tmpX1:(tmpX1+1),:) = level750;
tmpX1 = centerX - blocksizeX*4;
imcycle(tmpY1:tmpY2,tmpX1:(tmpX1+1),:) = level750;
tmpX1 = centerX + blocksizeX*4;
imcycle(tmpY1:tmpY2,tmpX1:(tmpX1+1),:) = level750;
tmpX1 = centerX + blocksizeX*6;
imcycle(tmpY1:tmpY2,tmpX1:(tmpX1+1),:) = level750;
%  ,  
for i = 0:(blocksizeY-linesizeY-1)
    tmpX = centerX - blocksizeX*7 - 5 + i*4;
    tmpY = centerY + blocksizeY - 1 - i;
    imcycle(tmpY:tmpY,tmpX:tmpX,:) = level375;
    imcycle(tmpY:tmpY,(tmpX+1):(tmpX+2),:) = level750;
    imcycle(tmpY:tmpY,(tmpX+3):(tmpX+3),:) = level375;
    tmpX = centerX + blocksizeX*4 - 9 + i*4;
    tmpY = centerY - 1 - i;
    imcycle(tmpY:tmpY,tmpX:tmpX,:) = level375;
    imcycle(tmpY:tmpY,(tmpX+1):(tmpX+2),:) = level750;
    imcycle(tmpY:tmpY,(tmpX+3):(tmpX+3),:) = level375;
end
%     
tmpY1 = centerY + blocksizeY*5 + linesizeY;
tmpY2 = centerY + blocksizeY*6 - 1;
tmpX1 = centerX - blocksizeX*5 + linesizeX;
tmpX2 = centerX - blocksizeX*4 + linesizeX - 1;
for i = 0:5
    imcycle(tmpY1:tmpY2,(tmpX1+i*2*blocksizeX):(tmpX2+i*2*blocksizeX),:) = minlevel;
end
%     
tmpX1 = centerX - blocksizeX*12 + linesizeX;
tmpX2 = centerX + blocksizeX*12 -1;
imout(tmpY1:tmpY2,tmpX1:tmpX2,:) = level750;
tmpX1 = centerX - blocksizeX*11;
tmpX2 = centerX - blocksizeX*7-1;
imout(tmpY1:tmpY2,tmpX1:tmpX2,:) = minlevel;
tmpX1 = centerX - blocksizeX*6;
tmpX2 = centerX - blocksizeX*5-1;
imout(tmpY1:tmpY2,tmpX1:tmpX2,:) = minlevel;
tmpX1 = centerX + blocksizeX*7;
tmpX2 = centerX + blocksizeX*11-1;
imout(tmpY1:tmpY2,tmpX1:tmpX2,:) = minlevel;
%  imout  imcycle   mask
for i = 1:3
    imout(:,:,i:i) = (imcycle(:,:,i:i) .* mask) + (imout(:,:,i:i) .* maskInv);
end
%
%     .
%  37.5%/75%  0%/75% 
tmpX1 = centerX - blocksizeX*12 + linesizeX;
tmpY1 = centerY - blocksizeY*5 + linesizeY;
tmpY2 = centerY - blocksizeY*3 - 1;
tmpY3 = centerY + blocksizeY*3 + linesizeY;
tmpY4 = centerY + blocksizeY*5 -1;
for i = 0:1:7
    tmpX2 = tmpX1 + blocksizeX*3 -1;
    if bitand(i,1) ~= 0
        imout(tmpY1:tmpY2,tmpX1:tmpX2,3:3) = level375;
        imout(tmpY3:tmpY4,tmpX1:tmpX2,3:3) = minlevel;
    else
        imout(tmpY1:tmpY2,tmpX1:tmpX2,3:3) = level750;
        imout(tmpY3:tmpY4,tmpX1:tmpX2,3:3) = level750;
    end
    if bitand(i,2) ~= 0
        imout(tmpY1:tmpY2,tmpX1:tmpX2,1:1) = level375;
        imout(tmpY3:tmpY4,tmpX1:tmpX2,1:1) = minlevel;
    else
        imout(tmpY1:tmpY2,tmpX1:tmpX2,1:1) = level750;
        imout(tmpY3:tmpY4,tmpX1:tmpX2,1:1) = level750;
    end
    if bitand(i,4) ~= 0
        imout(tmpY1:tmpY2,tmpX1:tmpX2,2:2) = level375;
        imout(tmpY3:tmpY4,tmpX1:tmpX2,2:2) = minlevel;
    else
        imout(tmpY1:tmpY2,tmpX1:tmpX2,2:2) = level750;
        imout(tmpY3:tmpY4,tmpX1:tmpX2,2:2) = level750;
    end
    tmpX1 = tmpX2 + 1;
end
%   
tmpY1 = centerY - blocksizeY*3;
tmpY2 = centerY - blocksizeY*2 + linesizeY - 1;
tmpX1 = centerX - blocksizeX*11;
tmpX2 = centerX - blocksizeX*9 - 1;
for i = 0:9
    imout(tmpY1:tmpY2,(tmpX1 + i*blocksizeX*2):(tmpX2+i*blocksizeX*2),:) = minlevel + razmah*i/9;
end
tmpX1 = centerX - blocksizeX*12;
imout(tmpY1:tmpY2,tmpX1:tmpX2,:) = minlevel;
tmpX1 = centerX + blocksizeX*9;
tmpX2 = centerX + blocksizeX*12 - 1;
imout(tmpY1:tmpY2,tmpX1:tmpX2,:) = minlevel;
proc3level = minlevel - 0.03 * razmah;
%  -3% > 0,  ,   
if proc3level > 0
    tmpX1 = centerX - blocksizeX*11;
    tmpX2 = centerX - blocksizeX*10 - 1;
    imout(tmpY1:tmpY2,tmpX1:tmpX2,:) = proc3level;
    tmpX1 = centerX + blocksizeX*10;
    tmpX2 = centerX + blocksizeX*11 - 1;
    imout(tmpY1:tmpY2,tmpX1:tmpX2,:) = proc3level;
end
%  
for i = 1:1000
    sin28(i,1:3) = level375 + razmah*sin(2*pi*2.8/fs*(i-1))/4;
    sin38(i,1:3) = level375 + razmah*sin(2*pi*3.8/fs*(i-1))/4;
    sin48(i,1:3) = level375 + razmah*sin(2*pi*4.8/fs*(i-1))/4;
    sin58(i,1:3) = level375 + razmah*sin(2*pi*5.8/fs*(i-1))/4;
end
%    
tmpY1 = centerY + blocksizeY*2;
tmpY2 = centerY + blocksizeY*3 + linesizeY - 1;
imout(tmpY1:tmpY2,(centerX-blocksizeX*12+linesizeX):(centerX+blocksizeX*12+linesizeX-1),:) = level375;
for i = tmpY1:tmpY2
    imout(i,(centerX-blocksizeX*11.5):(centerX-blocksizeX*8+linesizeX-1),:) = sin28(1:(blocksizeX*3.5+linesizeX),:);
    imout(i,(centerX-blocksizeX*7.5):(centerX-blocksizeX*5+linesizeX-1),:) = sin38(1:(blocksizeX*2.5+linesizeX),:);
    imout(i,(centerX-blocksizeX*4.5):(centerX-blocksizeX*2+linesizeX-1),:) = sin48(1:(blocksizeX*2.5+linesizeX),:);
    imout(i,(centerX-blocksizeX*1.5):(centerX+blocksizeX*2+linesizeX-1),:) = sin58(1:(blocksizeX*3.5+linesizeX),:);
    imout(i,(centerX+blocksizeX*2.5):(centerX+blocksizeX*5+linesizeX-1),:) = sin48(1:(blocksizeX*2.5+linesizeX),:);
    imout(i,(centerX+blocksizeX*5.5):(centerX+blocksizeX*8+linesizeX-1),:) = sin38(1:(blocksizeX*2.5+linesizeX),:);
    imout(i,(centerX+blocksizeX*8.5):(centerX+blocksizeX*12+linesizeX-1),:) = sin28(1:(blocksizeX*3.5+linesizeX),:);
end
%    
tmpX1 = centerX - blocksizeX*10 + linesizeX;
tmpX2 = centerX - blocksizeX*8 + linesizeX - 1;
tmpX3 = centerX + blocksizeX*8 + linesizeX;
tmpX4 = centerX + blocksizeX*10 + linesizeX - 1;
for i = (centerY - blocksizeY*8):(centerY - blocksizeY*8 + 19)
    imout(i,tmpX1:tmpX2,:) = sin38(1:(blocksizeX*2),:);
    imout(i,tmpX3:tmpX4,:) = sin38(1:(blocksizeX*2),:);
end
for i = (centerY - blocksizeY*6 - 18):(centerY - blocksizeY*6 - 1)
    imout(i,tmpX1:tmpX2,:) = sin48(1:(blocksizeX*2),:);
    imout(i,tmpX3:tmpX4,:) = sin48(1:(blocksizeX*2),:);
end
for i = (centerY + blocksizeY*6):(centerY + blocksizeY*6 + 19)
    imout(i,tmpX1:tmpX2,:) = sin48(1:(blocksizeX*2),:);
    imout(i,tmpX3:tmpX4,:) = sin48(1:(blocksizeX*2),:);
end
for i = (centerY + blocksizeY*8 - 18):(centerY + blocksizeY*8 - 1)
    imout(i,tmpX1:tmpX2,:) = sin38(1:(blocksizeX*2),:);
    imout(i,tmpX3:tmpX4,:) = sin38(1:(blocksizeX*2),:);
end
%  
cifir(1:8,1:4,1:10) = 0;
cifir(:,:,2) = [1 1 1 1; 0 0 0 1; 0 0 0 1; 0 0 1 0; 0 1 0 0; 1 0 0 0; 1 0 0 0; 1 1 1 1];
cifir(:,:,3) = [1 1 1 1; 0 0 0 1; 0 0 0 1; 0 1 1 0; 0 0 0 1; 0 0 0 1; 0 0 0 1; 1 1 1 1];
cifir(:,:,4) = [1 0 0 1; 1 0 0 1; 1 0 0 1; 1 1 1 1; 0 0 0 1; 0 0 0 1; 0 0 0 1; 0 0 0 1];
cifir(:,:,5) = [1 1 1 1; 1 0 0 0; 1 0 0 0; 1 1 1 1; 0 0 0 1; 0 0 0 1; 0 0 0 1; 1 1 1 1];
bigcifir(1:16,1:8,1:10) = 0;
for i = 1:10
    for i1 = 1:16
        for i2 = 1:8
            bigcifir(i1,i2,i) = cifir(floor((i1+1)/2),floor((i2+1)/2),i);
        end
    end
end
mask(:,:)=0;
filling(1:height,1:width) = minlevel;
%  
tmpY1 = centerY + blocksizeY*2.5 - 7;
tmpX1 = centerX - blocksizeX*12 + 4;
mask(tmpY1:tmpY1+15,tmpX1:tmpX1+7) = bigcifir(:,:,2);
tmpX1 = centerX - blocksizeX*8 + 4;
mask(tmpY1:tmpY1+15,tmpX1:tmpX1+7) = bigcifir(:,:,3);
tmpX1 = centerX - blocksizeX*5 + 4;
mask(tmpY1:tmpY1+15,tmpX1:tmpX1+7) = bigcifir(:,:,4);
tmpX1 = centerX - blocksizeX*2 + 4;
mask(tmpY1:tmpY1+15,tmpX1:tmpX1+7) = bigcifir(:,:,5);
tmpX1 = centerX + blocksizeX*2 + 4;
mask(tmpY1:tmpY1+15,tmpX1:tmpX1+7) = bigcifir(:,:,4);
tmpX1 = centerX + blocksizeX*5 + 4;
mask(tmpY1:tmpY1+15,tmpX1:tmpX1+7) = bigcifir(:,:,3);
tmpX1 = centerX + blocksizeX*8 + 4;
mask(tmpY1:tmpY1+15,tmpX1:tmpX1+7) = bigcifir(:,:,2);
filling = filling + mask * (level750 - minlevel);
% 
tmpX1 = centerX - blocksizeX*10.5 +4;
tmpY1 = centerY - blocksizeY*7.5 -7;
mask(tmpY1:tmpY1+15,tmpX1:tmpX1+7) = bigcifir(:,:,3);
tmpY1 = centerY - blocksizeY*6.5 -7;
mask(tmpY1:tmpY1+15,tmpX1:tmpX1+7) = bigcifir(:,:,4);
tmpY1 = centerY + blocksizeY*6.5 -7;
mask(tmpY1:tmpY1+15,tmpX1:tmpX1+7) = bigcifir(:,:,4);
tmpY1 = centerY + blocksizeY*7.5 -7;
mask(tmpY1:tmpY1+15,tmpX1:tmpX1+7) = bigcifir(:,:,3);
tmpX1 = centerX + blocksizeX*7.5 +4;
tmpY1 = centerY - blocksizeY*7.5 -7;
mask(tmpY1:tmpY1+15,tmpX1:tmpX1+7) = bigcifir(:,:,3);
tmpY1 = centerY - blocksizeY*6.5 -7;
mask(tmpY1:tmpY1+15,tmpX1:tmpX1+7) = bigcifir(:,:,4);
tmpY1 = centerY + blocksizeY*6.5 -7;
mask(tmpY1:tmpY1+15,tmpX1:tmpX1+7) = bigcifir(:,:,4);
tmpY1 = centerY + blocksizeY*7.5 -7;
mask(tmpY1:tmpY1+15,tmpX1:tmpX1+7) = bigcifir(:,:,3);
%  
maskInv = 1 - mask;
for i = 1:3
    imout(:,:,i) = imout(:,:,i) .* maskInv + mask .* filling;
end
%  
image(imout);
imwrite(imout,'c:\ueitm.bmp','bmp');
clear